#set of functions, directly/indirectly involved, in oneChannelGUI generalToolMenu
#oneChannelGUI   filteringTable filtering a tab delimited file on the basis of a list of probesets
#oneChannelGUI colExtract extract a user defined colum from a tab delimited file with header
#oneChannelGUI geneExonLibs queries affymetrix web site to download exon and gene 1.0 ST WT library files
#oneChannelGUI aptFolder setting the folder were apt tools are located (save data in localdata.txt in etc)
#oneChannelGUI deleteLocalData delete data in localdata.txt resetting aptDir and libDirLocation
#oneChannelGUI buildingLocalAnnotation updates gene level annotation using the netaffx annotation data
#oneChannelGUI refseqDownload retrieve the latest Hs, Mm, Rn refseq fasta file
#oneChannelGUI madscrosshybDownload and creation of mads derived mps file only available for Hs and Mm core  NOT FINISHED
#oneChannelGUI updateLibs run an update of the Bioconductor libraries
################################################################################
#this file contains a set of function that perfomr basic R function useful for handlying microarray data.
#this function filter a table on the basis of a vector of data present in an other file
"filteringTable" <- function(){
    Try(tkmessageBox(title="Table subsetting",message="Open the file to be filtered. This file should be tab delimited with an header."))
    Try(tempFileName <- tclvalue(tkgetOpenFile(filetypes="{{Text Files} {.txt}} {{All files} *}")))
    if(!nchar(tempFileName))
    {
       tkfocus(.affylmGUIglobals$ttMain)
       return()
    }
    Try(saving.file <- paste(tempFileName, ".filtered.by.",sep=""))
    Try(mySel<-read.table(tempFileName, sep="\t", header=T, as.is=TRUE, quote=""))
    Try(tkmessageBox(title="Table subsetting",message="Open the file to be used to filter the previous file.\nThis file should contain a single column with an header equal to \nthe one that should be used for filtering in the tab delimited file."))
    Try(tempFileName <- tclvalue(tkgetOpenFile(filetypes="{{Text Files} {.txt}} {{All files} *}")))
    if(!nchar(tempFileName))
    {
       tkfocus(.affylmGUIglobals$ttMain)
       return()
    }
    Try(tmp <- as.vector(unlist(strsplit(tempFileName , "/"))))
    Try(saving.file <- paste(saving.file, tmp[length(tmp)],sep=""))
    Try(myFilter<-read.table(tempFileName, sep="\t", header=T, as.is=TRUE, quote=""))
    Try(col.for.filter <- which(names(mySel)==names(myFilter)[1]))
    Try(mySel <- mySel[which(mySel[,col.for.filter]%in%myFilter[,1]),])
    Try(tkmessageBox(title="Table subsetting",message="Saving the filtered table."))
	  Try(FileName <- tclvalue(tkgetSaveFile(initialfile=saving.file, filetypes="{{Tab-Delimited Text Files} {.txt .xls}} {{All files} *}")))
    Try(if(!nchar(FileName))
		    	return())
		Try(write.table(mySel,file=FileName,quote=FALSE,col.names=NA,sep="\t"))
   
}
################################################################################
"colExtract" <- function(){
    Try(tkmessageBox(title="Column extraction",message="Open the file to be manipulated. This file should be tab delimited with an header."))
    Try(tempFileName <- tclvalue(tkgetOpenFile(filetypes="{{Text Files} {.txt}} {{All files} *}")))
    if(!nchar(tempFileName))
    {
       tkfocus(.affylmGUIglobals$ttMain)
       return()
    }
    Try(mySel<-read.table(tempFileName, sep="\t", header=T, as.is=TRUE, quote=""))
    Try(mycol <- names(mySel))
    Try(mycol <- paste(mycol, "=",seq(1, length(mycol)), sep="", collapse=" "))
    
          #selecting the column to be removed
                 Try(ttcolExtract<-tktoplevel(.affylmGUIglobals$ttMain))
                 Try(tkwm.deiconify(ttcolExtract))
                 Try(tkgrab.set(ttcolExtract))
                 Try(tkfocus(ttcolExtract))
                 Try(tkwm.title(ttcolExtract,"Defining the column to be estracted"))
                 Try(tkgrid(tklabel(ttcolExtract,text="    ")))
                 Try(colnum <- "1")
                 Try(Local.colExtract <- tclVar(init=colnum))
                 Try(entry.colExtract <-tkentry(ttcolExtract,width="4",font=.affylmGUIglobals$affylmGUIfont2,textvariable=Local.colExtract,bg="white"))
                 Try(tkgrid(tklabel(ttcolExtract,text=paste("Please enter the number associated to the columnof interest\n", mycol,collapse=" "),font=.affylmGUIglobals$affylmGUIfont2)))
                 Try(tkgrid(entry.colExtract))
                 onOK <- function()
                 {
                     Try(colnum <- as.numeric(tclvalue(Local.colExtract)))
                     Try(assign("colnum", as.numeric(tclvalue(Local.colExtract)),affylmGUIenvironment))
                     Try(tkgrab.release(ttcolExtract));Try(tkdestroy(ttcolExtract));Try(tkfocus(.affylmGUIglobals$ttMain))                        
                 }
                 Try(OK.but <-tkbutton(ttcolExtract,text="   OK   ",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
                 Try(tkgrid(tklabel(ttcolExtract,text="    ")))
                 Try(tkgrid(OK.but))
                 Try(tkgrid.configure(OK.but))
                 Try(tkgrid(tklabel(ttcolExtract,text="       ")))
                 Try(tkfocus(entry.colExtract))
                 Try(tkbind(entry.colExtract, "<Return>",onOK))
                 Try(tkbind(ttcolExtract, "<Destroy>", function(){Try(tkgrab.release(ttcolExtract));Try(tkfocus(.affylmGUIglobals$ttMain));return(0)}))
                 Try(tkwait.window(ttcolExtract))
                 Try(tkfocus(.affylmGUIglobals$ttMain))
                 Try(colnum <- get("colnum", affylmGUIenvironment))
                 if(colnum > length(names(mySel))){
                         Try(tkmessageBox(title="Column extraction",message="You have selected a non existing column!"))
                         return()
                 }
    
    Try(tempFileName <- as.vector(unlist(strsplit(tempFileName, "/"))))
    Try(if(length(tempFileName) > 1)  tempFileName <- tempFileName[length(tempFileName)])
    Try(saving.file <- paste("col.",colnum,".from.",tempFileName,".txt",sep=""))
    Try(tkmessageBox(title="Column extraction",message="Saving the extracted column."))
	  Try(FileName <- tclvalue(tkgetSaveFile(initialfile=saving.file, filetypes="{{Tab-Delimited Text Files} {.txt .xls}} {{All files} *}")))
    Try(if(!nchar(FileName))
		    	return())
    Try(myout <- as.character(as.vector(mySel[,colnum])))
    Try(zz <- file(FileName, "w"))
    Try(writeLines(myout, con = zz, sep = "\n"))
    Try(close(zz))

}
################################################################################
#save affy libraries in allylibs dir as new dir in oneChannelPath
 "geneExonLibs" <- function(){
      Try(tkmessageBox(title="Gene Exon 1.0 ST libraries",message="This routine installs, in a user defined folder,\nall library files needed for analysis of Gene/Exon Affymetrix arrays."))
      Try(myWD <- getwd())
      #Try(SetWD())
      Try(libDirLocation <- get("libDirLocation",envir=affylmGUIenvironment))
      if(libDirLocation != ""){
             Try(mbVal <- tkmessageBox(title="Gene Exon 1.0 ST libraries",
				    											message="There already a folder defined for Affymetrix libraries.\nDo you want to change it?",
						    									icon="question",type="yesno",default="no"
								    						 )#end of tkmessageBox
		        )#end of Try(mbVal..
    		    if(tclvalue(mbVal)=="no"){
			            Try(tkfocus(.affylmGUIglobals$ttMain))
			            Try(setwd(myWD))
			            return()
		       } else{
                    Try(.downloadLibs())
                    Try(setwd(myWD))
                    return()
           } 
      }
   Try(.downloadLibs())
   Try(setwd(myWD))
}

".downloadLibs" <- function(){
                     Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="watch"))
                     Try(libDirLocation  <- paste(.path.package("oneChannelGUI", quiet = FALSE), "/affylibs", sep=""))
                     Try(dir.create(libDirLocation, showWarnings = TRUE, recursive = FALSE))
                     Try(setwd(libDirLocation))
                     Try(assign("libDirLocation", libDirLocation, affylmGUIenvironment))#directory where affy library files are located
                     Try(cat("\nBegin downloads of library files.....\n"))
                     Try(cat("Be patient!\n"))
                     Try(download.file("http://www.bioinformatica.unito.it/downloads/HuEx-1_0-st-v2.r2.zip", "HuEx-1_0-st-v2.r2.zip", mode="wb"))
                     Try(download.file("http://www.bioinformatica.unito.it/downloads/HuGene-1_0-st-v1.r3.analysis_libraryfile.zip","HuGene-1_0-st-v1.r3.analysis_libraryfile.zip", mode="wb"))
                     Try(download.file("http://www.bioinformatica.unito.it/downloads/MoEx-1_0-st-v1.r2.zip", "MoEx-1_0-st-v1.r2.zip", mode="wb"))
                     Try(download.file("http://www.bioinformatica.unito.it/downloads/MoGene-1_0-st-v1.r3.analysis-lib-files.zip","MoGene-1_0-st-v1.r3.analysis-lib-files.zip", mode="wb"))
                     Try(download.file("http://www.bioinformatica.unito.it/downloads/RaEx-1_0-st-v1.r2.zip","RaEx-1_0-st-v1.r2.zip", mode="wb"))
                     Try(download.file("http://www.bioinformatica.unito.it/downloads/RaGene-1_0-st-v1.r3.analysis-lib-files.zip","RaGene-1_0-st-v1.r3.analysis-lib-files.zip", mode="wb"))

               #      Try(download.file("http://www.affymetrix.com/Auth/support/downloads/library_files/HuEx-1_0-st-v2.r2.zip", "HuEx-1_0-st-v2.r2.zip", method="wget"))
               #      Try(download.file("http://www.affymetrix.com/Auth/support/downloads/library_files/MoEx-1_0-st-v1_libraryfile.zip", "MoEx-1_0-st-v1_libraryfile.zip"))
               #      Try(download.file("http://www.affymetrix.com/Auth/support/downloads/library_files/RaEx-1_0-st-v1_libraryfile.zip","RaEx-1_0-st-v1_libraryfile.zip"))
               #      Try(download.file("http://www.affymetrix.com/Auth/support/downloads/library_files/HuGene-1_0-st-v1.r3.analysis_libraryfile.zip","HuGene-1_0-st-v1.r3.analysis_libraryfile.zip"))
                     Try(cat("\nEnd downloads of 6 library files.....\n"))
                     Try(cat("\nBegin unzip library files.....\n"))
                     if(.Platform$OS.type=="windows"){
                         Try(unzipped1 <- zip.unpack("HuGene-1_0-st-v1.r3.analysis_libraryfile.zip", getwd()))
                         Try(if(!unzipped1) cat("\nHuGene correctly unzipped\n"))
                         Try(unzipped2 <- zip.unpack("HuEx-1_0-st-v2.r2.zip", getwd()))
                         Try(if(!unzipped2) cat("\nHuEx correctly unzipped\n"))
                         Try(unzipped3 <- zip.unpack("MoEx-1_0-st-v1.r2.zip", getwd()))
                         Try(if(!unzipped3) cat("\nMoEx correctly unzipped\n"))
                         Try(unzipped4 <- zip.unpack("MoGene-1_0-st-v1.r3.analysis-lib-files.zip", getwd()))
                         Try(if(!unzipped4) cat("\nMoGene correctly unzipped\n"))
                         Try(unzipped5 <- zip.unpack("RaEx-1_0-st-v1.r2.zip", getwd()))
                         Try(if(!unzipped5) cat("\nRaEx correctly unzipped\n"))
                         Try(unzipped6 <- zip.unpack("RaGene-1_0-st-v1.r3.analysis-lib-files.zip", getwd()))
                         Try(if(!unzipped6) cat("\nRaGene correctly unzipped\n"))
                     } else{
                       Try(system(paste("unzip HuGene-1_0-st-v1.r3.analysis_libraryfile.zip", sep="")))
                       Try(system(paste("unzip HuEx-1_0-st-v2.r2.zip")))
                       Try(system(paste("unzip MoEx-1_0-st-v1.r2.zip")))
                       Try(system(paste("unzip MoGene-1_0-st-v1.r3.analysis-lib-files.zip")))
                       Try(system(paste("unzip RaEx-1_0-st-v1.r2.zip")))
                       Try(system(paste("unzip RaGene-1_0-st-v1.r3.analysis-lib-files.zip")))
                     }
                     Try(cat("\nEnd unzip library files.....\n"))
                     Try(cat("\nLibrary files are ready to be used in ", getwd(),"\n"))
                     #save the info to be recovered in a new session
                     Try(etcDir  <- paste(.path.package("oneChannelGUI", quiet = FALSE), "/etc", sep=""))
                     Try(localdata <- paste(etcDir, "/localData.txt", sep=""))
                     Try(myinfo <- read.table(localdata, sep="\t", header=F, as.is=T))
                     Try(myinfo[which(myinfo[,1]=="libDirLocation"),2] <- libDirLocation)
                     Try(write.table(myinfo, localdata, sep="\t", row.names=F, col.names=F, quote=F))
                     Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
}
#######################################################################################################
#define the folder where apt tools are locate
"aptFolder" <- function(){
      Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="watch"))
      Try(tkmessageBox(title="APT tools folder",message="Please select the folder where APT tools are located."))
      Try(myWD <- getwd())
      #Try(SetWD())
      Try(aptDir <- get("aptDir",envir=affylmGUIenvironment))
      if(is.na(aptDir)){aptDir <- ""}
      if(aptDir == ""){
            Try(SetED())
            Try(aptDir <- getwd())
            if(length(grep("apt-probeset-summarize", dir(paste(aptDir, "/bin", sep="")))) == 0){
                      Try(tkmessageBox(title="APT tools dir ",message="You have not correctly defined the main folder where APT tools are located!",icon="error"))
                      assign("aptDir.Available",FALSE,affylmGUIenvironment)
                      assign("aptDir", "" ,affylmGUIenvironment)
                      Try(setwd(myWD))
                      #Try(return())
            } else {
                       Try(localdata  <- paste(.path.package("oneChannelGUI", quiet = FALSE), "/etc/localData.txt", sep=""))
                       Try(myinfo <- read.table(localdata, sep="\t", header=F, as.is=T))
                       Try(myinfo[which(myinfo[,1]=="aptDir"),2] <- aptDir)
                       Try(write.table(myinfo, localdata, sep="\t", row.names=F, col.names=F, quote=F))
                       assign("aptDir.Available",TRUE,affylmGUIenvironment)
                       assign("aptDir", aptDir ,affylmGUIenvironment)
                       Try(setwd(myWD))
                       #Try(return())
            }
      } else{
                      Try(mbVal <- tkmessageBox(title="APT tools folder",
				    											message="There already a folder defined for APT tools.\nDo you want to change it?",
						    									icon="question",type="yesno",default="no"
								    						 )#end of tkmessageBox
		                  )#end of Try(mbVal..
    		              if(tclvalue(mbVal)=="no"){
			                        Try(tkfocus(.affylmGUIglobals$ttMain))
			                        Try(setwd(myWD))
			                        return()
		                  } 
                      if(tclvalue(mbVal)=="yes"){
                              Try(SetED())
                              Try(aptDir <- getwd())
                              if(length(grep("apt-probeset-summarize", dir(paste(aptDir, "/bin", sep="")))) == 0){
                                  Try(tkmessageBox(title="APT tools dir ",message="You have not correctly defined the main folder where APT tools are located!",icon="error"))
                                  assign("aptDir.Available",FALSE,affylmGUIenvironment)
                                  assign("aptDir", "" ,affylmGUIenvironment)
                                  Try(setwd(myWD))
                                  #Try(return())
                              } else {
                                 Try(localdata  <- paste(.path.package("oneChannelGUI", quiet = FALSE), "/etc/localData.txt", sep=""))
                                 Try(myinfo <- read.table(localdata, sep="\t", header=F, as.is=T))
                                 Try(myinfo[which(myinfo[,1]=="aptDir"),2] <- aptDir)
                                 Try(write.table(myinfo, localdata, sep="\t", row.names=F, col.names=F, quote=F))
                                 assign("aptDir.Available",TRUE,affylmGUIenvironment)
                                 assign("aptDir", aptDir ,affylmGUIenvironment)
                                 Try(setwd(myWD))
                                 #Try(return())
                             }
                      }      
           }
           
           Try(mbVal <- tkmessageBox(title="RefSeq Fasta",
				    											message="Do you wish to download reference sequence for exon-level analysis?\nIf you answer NO oneChannelGUI you can also do it later. Be patient!",
						    									icon="question",type="yesno",default="no"
								    						 )#end of tkmessageBox
		  )#end of Try(mbVal..
    	if(tclvalue(mbVal)=="yes"){
			            Try(tkfocus(.affylmGUIglobals$ttMain))
			            Try(refseqDownload())
                  Try(tkmessageBox(title="APT tools folder",message="Please install the BLAST executable in the apt/blast dir.\nDownload the BAST from ftp://ftp.ncbi.nih.gov/blast/executables/LATEST"))
      }
      Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
}
###########################################################################################
"deleteLocalData" <- function(){
          Try(mbVal <- tkmessageBox(title="Local setting",
				    											message="Do you want to the delete the local setting for Gene Exon arrays analysis?",
						    									icon="question",type="yesno",default="no"
								    						 )#end of tkmessageBox
		        )#end of Try(mbVal..
    		    if(tclvalue(mbVal)=="no"){
			            Try(tkfocus(.affylmGUIglobals$ttMain))
			            return()
		       } else{
                    Try(etcDir  <- paste(.path.package("oneChannelGUI", quiet = FALSE), "/etc", sep=""))
                    Try(localdata <- paste(etcDir, "/localData.txt", sep=""))
                    Try(myinfo <- read.table(localdata, sep="\t", header=F, as.is=T))
                    Try(myinfo[which(myinfo[,1]=="libDirLocation"),2] <- "")
                    Try(myinfo[which(myinfo[,1]=="aptDir"),2] <- "")
                    Try(write.table(myinfo, localdata, sep="\t", row.names=F, col.names= F, quote=F))
                    Try(tkmessageBox(title="Local settings",message="Local setting were reset."))
                    return()
           } 

}
################################################################################
#building gene and exon annotation for oneChannelGUI 
buildingLocalAnnotation <- function(){
    Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="watch"))
    Try(require("AffyCompatible") || stop("\nMissing AffyCompatible library\n"))
    Try(libDirLocation <- paste(.path.package("oneChannelGUI", quiet = FALSE), "/affylibs/", sep = ""))
    #gathering affy libs and apt tools folders
    Try(netaffxUpdates  <- paste(.path.package("oneChannelGUI", quiet = FALSE), "/etc/netaffxUpdates.txt", sep=""))
    Try(cat(readLines(netaffxUpdates), sep="\n"))
    #username
    Try(ttGetUserName<-tktoplevel(.affylmGUIglobals$ttMain))
    Try(tkwm.deiconify(ttGetUserName))
    Try(tkgrab.set(ttGetUserName))
    Try(tkfocus(ttGetUserName))
    Try(tkwm.title(ttGetUserName,"NetAffx User Name"))
    Try(tkgrid(tklabel(ttGetUserName,text="    ")))
    Try(UserNameText <- "")
    Try(Local.UserName <- tclVar(init=UserNameText))
    Try(entry.UserName <-tkentry(ttGetUserName,width="30",font=.affylmGUIglobals$affylmGUIfont2,textvariable=Local.UserName,bg="white"))
    Try(tkgrid(tklabel(ttGetUserName,text="Please enter your NetAffx User Name.",font=.affylmGUIglobals$affylmGUIfont2)))
    Try(tkgrid(entry.UserName))
    onOK <- function()
    {
       Try(UserNameText <- tclvalue(Local.UserName))
       if(nchar(UserNameText)==0)
           UserNameText <- "Unselected"
       Try(assign("UserNameText",UserNameText,affylmGUIenvironment))
       Try(tclvalue(.affylmGUIglobals$UserNameTcl) <- UserNameText)
       Try(tkgrab.release(ttGetUserName));Try(tkdestroy(ttGetUserName));Try(tkfocus(.affylmGUIglobals$ttMain))
    }
    Try(OK.but <-tkbutton(ttGetUserName,text="   OK   ",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
    Try(tkgrid(tklabel(ttGetUserName,text="    ")))
    Try(tkgrid(OK.but))
    Try(tkgrid.configure(OK.but))
    Try(tkgrid(tklabel(ttGetUserName,text="       ")))
    Try(tkfocus(entry.UserName))
    Try(tkbind(entry.UserName, "<Return>",onOK))
    Try(tkbind(ttGetUserName, "<Destroy>", function(){Try(tkgrab.release(ttGetUserName));Try(tkfocus(.affylmGUIglobals$ttMain));return(0)}))
    Try(tkwait.window(ttGetUserName))
    Try(tkfocus(.affylmGUIglobals$ttMain))
    #########################
    #password
    Try(ttGetUserPw<-tktoplevel(.affylmGUIglobals$ttMain))
    Try(tkwm.deiconify(ttGetUserPw))
    Try(tkgrab.set(ttGetUserPw))
    Try(tkfocus(ttGetUserPw))
    Try(tkwm.title(ttGetUserPw,"NetAffx User Password"))
    Try(tkgrid(tklabel(ttGetUserPw,text="    ")))
    Try(UserPwText <- "")
    Try(Local.UserPw <- tclVar(init=UserPwText))
    Try(entry.UserPw <-tkentry(ttGetUserPw,width="20",font=.affylmGUIglobals$affylmGUIfont2,textvariable=Local.UserPw,bg="white"))
    Try(tkgrid(tklabel(ttGetUserPw,text="Please enter your NetAffx User Password.",font=.affylmGUIglobals$affylmGUIfont2)))
    Try(tkgrid(entry.UserPw))
    onOK <- function()
    {
       Try(UserPwText <- tclvalue(Local.UserPw))
       if(nchar(UserPwText)==0)
           UserPwText <- "Unselected"
       Try(assign("UserPwText",UserPwText,affylmGUIenvironment))
       Try(tclvalue(.affylmGUIglobals$UserPwTcl) <- UserPwText)
       Try(tkgrab.release(ttGetUserPw));Try(tkdestroy(ttGetUserPw));Try(tkfocus(.affylmGUIglobals$ttMain))
    }
    Try(OK.but <-tkbutton(ttGetUserPw,text="   OK   ",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
    Try(tkgrid(tklabel(ttGetUserPw,text="    ")))
    Try(tkgrid(OK.but))
    Try(tkgrid.configure(OK.but))
    Try(tkgrid(tklabel(ttGetUserPw,text="       ")))
    Try(tkfocus(entry.UserPw))
    Try(tkbind(entry.UserPw, "<Return>",onOK))
    Try(tkbind(ttGetUserPw, "<Destroy>", function(){Try(tkgrab.release(ttGetUserPw));Try(tkfocus(.affylmGUIglobals$ttMain));return(0)}))
    Try(tkwait.window(ttGetUserPw))
    Try(tkfocus(.affylmGUIglobals$ttMain))
    #########################
    Try(username.tmp <- get("UserNameText", env=affylmGUIenvironment))
    Try(userpw.tmp <- get("UserPwText", env=affylmGUIenvironment))
    if(username.tmp != "Unselected" & userpw.tmp != "Unselected"){
         Try(rsrc <- NetAffxResource(user = username.tmp, password = userpw.tmp, affxLicence = "BIOCON0808"))
         Try(rsrc)
         #selecting the annotation to be updated
         Try(ttIfDialog<-tktoplevel(.affylmGUIglobals$ttMain))
         Try(tkwm.deiconify(ttIfDialog))
         Try(tkgrab.set(ttIfDialog))
         Try(tkfocus(ttIfDialog))
         Try(tkwm.title(ttIfDialog,"Defining the Gene level annotation file to be updated"))
         Try(tkgrid(tklabel(ttIfDialog,text="    ")))
         Try(frame1 <- tkframe(ttIfDialog,relief="groove",borderwidth=2))
         Try(HowManyQuestion1 <- tklabel(frame1,text="Select the genechip of interest",font=.affylmGUIglobals$affylmGUIfont2))
         Try(tkgrid(HowManyQuestion1))
         Try(tkgrid.configure(HowManyQuestion1,columnspan=2,sticky="w"))
         Try(netaffxTcl <- tclVar("none"))
         Try(I1.but  <- tkradiobutton(frame1,text="Human exon genechip: HuEx",variable=netaffxTcl,value="HuEx",font=.affylmGUIglobals$affylmGUIfont2))
         Try(I2.but  <- tkradiobutton(frame1,text="Human gene genechip: HuGene",variable=netaffxTcl,value="HuGene-",font=.affylmGUIglobals$affylmGUIfont2))
         Try(I3.but  <- tkradiobutton(frame1,text="Mouse exon genechip: MoEx",variable=netaffxTcl,value="MoEx",font=.affylmGUIglobals$affylmGUIfont2))
         Try(I4.but  <- tkradiobutton(frame1,text="Mouse gene genechip: MoGene",variable=netaffxTcl,value="MoGene-",font=.affylmGUIglobals$affylmGUIfont2))
         Try(I5.but  <- tkradiobutton(frame1,text="Rat exon genechip: RaEx",variable=netaffxTcl,value="RaEx",font=.affylmGUIglobals$affylmGUIfont2))
         Try(I6.but  <- tkradiobutton(frame1,text="Rat gene genechip: RaGene",variable=netaffxTcl,value="RaGene-",font=.affylmGUIglobals$affylmGUIfont2))
         Try(I7.but  <- tkradiobutton(frame1,text="None",variable=netaffxTcl,value="none",font=.affylmGUIglobals$affylmGUIfont2))
         Try(tkgrid(I1.but,sticky="w"))
         Try(tkgrid(I2.but,sticky="w"))
         Try(tkgrid(I3.but,sticky="w"))
         Try(tkgrid(I4.but,sticky="w"))
         Try(tkgrid(I5.but,sticky="w"))
         Try(tkgrid(I6.but,sticky="w"))
         Try(tkgrid(I7.but,sticky="w"))
         Try(tkgrid.configure(HowManyQuestion1,I1.but,I2.but,I3.but,I4.but,I5.but,I6.but,I7.but,sticky="w"))
         Try(onOK <- function()
         {
             Try(ReturnNetaffx <<- as.character(tclvalue(netaffxTcl)))
             Try(tkgrab.release(ttIfDialog))
             Try(tkdestroy(ttIfDialog))
             Try(tkfocus(.affylmGUIglobals$ttMain))
         })
         Try(frame3 <- tkframe(ttIfDialog,borderwidth=2))
         Try(onCancel <- function() {
              Try(tkgrab.release(ttIfDialog))
              Try(tkdestroy(ttIfDialog))
              Try(tkfocus(.affylmGUIglobals$ttMain))
              Try(return())
         })
         Try(OK.but <-tkbutton(frame3,text="   OK   ",command=onOK,font=.affylmGUIglobals$affylmGUIfont2))
         Try(Cancel.but <-tkbutton(frame3,text=" Cancel ",command=onCancel,font=.affylmGUIglobals$affylmGUIfont2))
         Try(tkgrid(tklabel(frame3,text="    "),OK.but,Cancel.but,tklabel(frame3,text="    ")))
         Try(tkgrid(tklabel(ttIfDialog,text="    "),frame1,tklabel(ttIfDialog,text="  ")))
         Try(tkgrid(tklabel(ttIfDialog,text="    ")))
         Try(tkgrid(tklabel(ttIfDialog,text="    "),frame3,tklabel(ttIfDialog,text="  ")))
         Try(tkgrid(tklabel(ttIfDialog,text="    ")))
         Try(tkgrid.configure(frame1,frame3,sticky="w"))
         Try(tkfocus(ttIfDialog))
         Try(tkbind(ttIfDialog, "<Destroy>", function() {Try(tkgrab.release(ttIfDialog));Try(tkfocus(.affylmGUIglobals$ttMain));}))
         Try(tkwait.window(ttIfDialog))
         if(ReturnNetaffx == "none"){
                Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
          	    Try(tkfocus(.affylmGUIglobals$ttMain))
                Try(return())
         }
         if(ReturnNetaffx != "none"){
               Try(annos <- rsrc[[grep(ReturnNetaffx, names(rsrc))]])
               Try(anno <- affxAnnotation(annos)[[grep("Transcript Cluster Annotations, CSV", affxDescription(rsrc[[grep(ReturnNetaffx, names(rsrc))]]))]])   #"transcript clusters Annotation, CSV Format"
               Try(df <- readAnnotation(rsrc, annotation = anno, content=FALSE))
               Try(df1 <- as.character(unlist(strsplit(df, ".zip"))))
               Try(df1 <- as.character(unlist(strsplit(df1,'/'))))
               Try(df1 <- df1[length(df1)])
               Try(conn <- unz(df, df1))
               Try(tmp <- readLines(conn, n=500))
               Try(myskip <- grep("transcript_cluster_id", tmp))
               Try(df.ann <- read.csv(conn, skip= (myskip - 1), header=T, as.is=T))
               Try(df.ann <- df.ann[,which(names(df.ann)%in%c("probeset_id", "gene_assignment"))])
               #IMPORTANT to build the GENE level oneChannelGUI annotation file I use only the first assignment mapped on the gen_assignment field in the annotation files
               
               geneAnnExtraction <- function(x){
                                                 mx <- strsplit(x, '//')
                                                 mx <- as.vector(unlist(mx))
                                                 if(length(mx) >= 4){
                                                       mx <- mx[1:4]
                                                       mxtmp <- gsub(" ", "", mx[c(1:2,4)])
                                                       mx <- c(mxtmp[1:2], mx[3], mxtmp[3])
                                                       return(mx)
                                                 } else{
                                                     mx <- rep(NA, 4)
                                                     return(mx)
                                                 }
                                    }
               
               myann <- sapply(df.ann[,2], geneAnnExtraction)
               myann <- t(myann)
               rownames(myann) <- df.ann[,1]
               df.ann <- cbind(df.ann[,1], myann)
               df.ann <- as.data.frame(df.ann)
               names(df.ann) <- c("PROBESETID","ACC","SYMBOL","DESCRIPTION","CYTOBAND")
               
               if(ReturnNetaffx == "HuEx"){
                       huex.annotation <- df.ann
                       save(huex.annotation, file="huex.annotation.rda")
               }
               if(ReturnNetaffx == "HuGene-"){
                       hugene.annotation <- df.ann
                       save(hugene.annotation, file="hugene.annotation.rda")
               }
               if(ReturnNetaffx == "MoEx"){
                       moex.annotation <- df.ann
                       save(moex.annotation, file="moex.annotation.rda")
               }
               if(ReturnNetaffx == "MoGene-"){
                       mogene.annotation <- df.ann
                       save(mogene.annotation, file="mogene.annotation.rda")
               }
               if(ReturnNetaffx == "RaEx"){
                       raex.annotation <- df.ann
                       save(raex.annotation, file="raex.annotation.rda")
               }
               if(ReturnNetaffx == "RaGene-"){
                       ragene.annotation <- df.ann
                       save(ragene.annotation, file="ragene.annotation.rda")
               }
               
               Try(tkmessageBox(title="Annotation data update",message=paste("\n", ReturnNetaffx, "annotation file was correctly updated in oneChannelGUI\n"),type="ok",icon="info"))
               Try(zz <- file(netaffxUpdates, "a"))  # open an output file connection
               Try(writeLines(paste(ReturnNetaffx, "annotation file was updated on", as.character(Sys.Date())), zz))
               Try(close(zz))
         }
    } else {
         Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
         Try(tkmessageBox(title="Annotation update",message="User or password for netaffx was not inserted!",type="ok",icon="error"))
   	     Try(tkfocus(.affylmGUIglobals$ttMain))
         Try(return())
    }
    
    Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
    Try(return())
}
################################################################################
"refseqDownload" <- function(){
       Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="watch"))
       Try(aptDir <- get("aptDir",envir=affylmGUIenvironment))
       Try(home <- getwd())
       Try(blastDir <- paste(aptDir, "/blast/", sep=""))
       Try(setwd(blastDir))
       Try(cat("\nBegin downloads of fasta files.....\n"))
       Try(cat("Be patient!\n"))
       require(Biostrings) || stop("library Biostrings could not be found !")
       Try(download.file("ftp://ftp.ncbi.nih.gov/refseq/H_sapiens/mRNA_Prot/human.rna.fna.gz", "human.rna.fna.gz", mode="wb"))
       #Try(refseq <- read.DNAStringSet(zz, "fasta"))
       #Try(write.XStringSet(refseq, file="hs.fa", format="fasta"))
       Try(download.file("ftp://ftp.ncbi.nih.gov/refseq/M_musculus/mRNA_Prot/mouse.rna.fna.gz", "mouse.rna.fna.gz", mode="wb"))
       Try(download.file("ftp://ftp.ncbi.nih.gov/refseq/R_norvegicus/mRNA_Prot/rat.rna.fna.gz", "rat.rna.fna.gz", mode="wb"))
       Try(cat("\nEnd downloads of 3 RefSeq fasta files.....\n"))
       Try(mbVal <- tkmessageBox(title="RefSeq Fasta",
				    											message=paste("Do you wish to unpack manually the gz files in ", getwd(), "\n If you answer NO oneChannelGUI will handle unpacking,\nbut the procedure can be quite long. Be patient!"),
						    									icon="question",type="yesno",default="no"
								    						 )#end of tkmessageBox
		  )#end of Try(mbVal..
    	if(tclvalue(mbVal)=="yes"){
			            Try(tkfocus(.affylmGUIglobals$ttMain))
			            Try(cat("\nRefSeq fasta gz files are located in ", getwd(),"\n"))
			            Try(setwd(home))
			            return()
		  }
      Try(zz <- gzfile("human.rna.fna.gz", "r"))
      Try(refseq <- readFASTA(zz, strip.desc=TRUE))
      Try(writeFASTA(refseq, file="human.rna.fna", width=80))
      Try(zz <- gzfile("mouse.rna.fna.gz", "r"))
      Try(refseq <- readFASTA(zz, strip.desc=TRUE))
      Try(writeFASTA(refseq, file="mouse.rna.fna", width=80))
      Try(zz <- gzfile("rat.rna.fna.gz", "r"))
      Try(refseq <- readFASTA(zz, strip.desc=TRUE))
      Try(writeFASTA(refseq, file="rat.rna.fna", width=80))
                 
      Try(cat("\nRefSeq fasta files are ready to be used in ", getwd(),"\n"))
      Try(setwd(home))
      Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))              
}

################################################################################
#"madscrosshybDownload" <- function(){
#    Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="watch"))
#    Try(home <- getwd())
#    Try(libDirLocation <- paste(.path.package("oneChannelGUI", quiet = FALSE), "/affylibs/", sep = ""))
#    Try(setwd(libDirLocation))
    #gathering affy libs and apt tools folders
#    Try(cat("\nBegin downloads of MADS CrossHyb data.....\n"))
#    Try(cat("Be patient!\n"))
#    Try(download.file("http://biogibbs.stanford.edu/~yxing/MADS/Human_CrossHyb.txt", "Human_CrossHyb.txt", mode="w"))
#    Try(download.file("http://biogibbs.stanford.edu/~yxing/MADS/Mouse_CrossHyb.txt", "Mouse_CrossHyb.txt", mode="w"))
#    Try(download.file("http://biogibbs.stanford.edu/~yxing/MADS/Human_CrossHyb_core.txt", "Human_CrossHyb_core.txt", mode="w"))
#    Try(download.file("http://biogibbs.stanford.edu/~yxing/MADS/Mouse_CrossHyb_core.txt", "Mouse_CrossHyb_core.txt", mode="w"))
#    Try(cat("\nEnd downloads of Human and Mouse MADS crosshyb files.....\n"))
#    hs <- read.table("Human_CrossHyb_core.txt", sep="\t", header=T, as.is=T)
    
    #building a mps without crosshyb exon probe sets, selecting bad probes on the basis of MADS approach
#    mm <- read.table("Mouse_CrossHyb_core.txt", sep="\t", header=T, as.is=T)
#    crossRefs <- which(mm$MaxCorrCrossHybRefseqEvidence > 0)
    #hist(MaxCorrWithCrossHybTranscript[crossRefs])
#    mm.cross <- mm[crossRefs,]
#    mm.cross <- mm.cross[which(mm.cross$MaxCorrWithCrossHybTranscript >= 0.2),]
#    mps <- mps[grep("core", mps)]
#    mps <- mps[grep("mps$", mps)]
#    mps.df <- read.table(mps, sep="\t", header=T, as.is=T)
#    for(i in 1:dim(mm.cross)[1]){
#      tmp <- mps.df[which(mps.df[,2] == mm.cross$TranscriptClusterId[1]),]
#      tmp.p <- as.character(unlist(strsplit(as.character(tmp[3])," ")))
#      tmp.p <- tmp.p[which(tmp.p != as.character(mm.cross$ProbesetId[1]))]
#      tmp.p <- paste(tmp.p, collapse=" ")
#      mps.df[which(mps.df[,2] == mm.cross$TranscriptClusterId[1]),3] <- tmp.p
      #write.table.....
#    } 
#    Try(setwd(home))
#}

################################################################################
"updateLibs" <- function(){
     Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="watch"))
     Try(mbVal <- tkmessageBox(title="Updating Bioconductor Libraries",
				    											message="You are updating all Bioconductor libraries files. \nThe process might take some time!", icon="question",type="yesno",default="yes"
								    						 )#end of tkmessageBox
		  )#end of Try(mbVal..
    	if(tclvalue(mbVal)=="no"){
			            Try(tkfocus(.affylmGUIglobals$ttMain))
                  return()
		  }
      source("http://bioconductor.org/biocLite.R")
      update.packages(repos=biocinstallRepos(), ask=FALSE)
      Try(tkconfigure(.affylmGUIglobals$ttMain,cursor="arrow"))
      return()
}
################################################################################


